'''
Created on 14.12.2010

@author: myron
'''

import time
from OpenGL.GLUT import *
from OpenGL.GL import *
from OpenGL.GLU import *
from string import split
from Model import Model
from math import *
from numpy import *

model = 0

fi = 1.565 #0.7
xi = 0.195 #0.7
vzd = 36.0

width = 500
height = 500

selectedPartId = -1
mousePosition = (0,0)

def displayFunc( picking=False ):
    global model
    #print 'display'
    glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT)
    
    glMatrixMode(GL_MODELVIEW)

    glLoadIdentity()
    
    ex = vzd*cos(fi)*cos(xi)
    ey = vzd*sin(fi)*cos(xi)
    ez = vzd*sin(xi)
    
    #gluLookAt( ex, ey, ez, 0, 0, 0, 0, 0, 1 )
    gluLookAt( ex, ez, ey, 0, 0, 0, 0, 1, 0 )
    
    
    glBegin(GL_LINES)
    #x
    glColor3f( 1.0, 0.0, 0.0 )
    
    glVertex3i( -10, 0, 10)
    glVertex3i( 10, 0, 10)
    
    glVertex3i( -10, 0, -10)
    glVertex3i( 10, 0, -10)
    
    glVertex3i( -10, 10, 10)
    glVertex3i( 10, 10, 10)
    
    glVertex3i( -10, 10, -10)
    glVertex3i( 10, 10, -10)
    #y
    glColor3f( 0.0, 1.0, 0.0 )
    
    glVertex3i( 10, 0, 10)
    glVertex3i( 10, 10, 10)
    
    glVertex3i( 10, 0, -10)
    glVertex3i( 10, 10, -10)
    
    glVertex3i( -10, 0, 10)
    glVertex3i( -10, 10, 10)
    
    glVertex3i( -10, 0, -10)
    glVertex3i( -10, 10, -10)
    
    #z    
    glColor3f( 0.0, 0.0, 1.0 )
    
    glVertex3i( 10, 0, -10)
    glVertex3i( 10, 0, 10)
    
    glVertex3i( -10, 0, -10)
    glVertex3i( -10, 0, 10)
    
    glVertex3i( 10, 10, -10)
    glVertex3i( 10, 10, 10)
    
    glVertex3i( -10, 10, -10)
    glVertex3i( -10, 10, 10)
    
    glEnd()
    
    #glColor3f( 0.0, 1.0, 1.0 )
    
    model.draw( picking )
    
    if not picking:
        glutSwapBuffers()

def initGL(width, height):               
    glClearColor(0.3, 0.3, 0.3, 0.5)
    glClearDepth(1.0)
    glEnable(GL_DEPTH_TEST)
    glDepthFunc(GL_LEQUAL)
    glHint(GL_PERSPECTIVE_CORRECTION_HINT, GL_NICEST)
    
    #glEnable(GL_LIGHT0)
    #glEnable(GL_LIGHTING)
    #glEnable(GL_COLOR_MATERIAL)
    
        
    glMatrixMode(GL_PROJECTION)
    glLoadIdentity()         
    gluPerspective(45.0, float(width)/float(height), 0.1, 100.0)
    glMatrixMode(GL_MODELVIEW)
    
def reSizeGLScene(width1, height1):
    global width, height
    
    if height1 == 0: 
        height1 = 1

    width = width1
    height = height1 

    glViewport(0, 0, width, height)      
    glMatrixMode(GL_PROJECTION)
    glLoadIdentity()
    gluPerspective(45.0, float(width)/float(height), 1, 5000.0)
    glMatrixMode(GL_MODELVIEW)
    glLoadIdentity()
    
def mouseMotion(x,y):
    pass
    
def doPick(x,y):
    global model, width, height
    
    viewport = glGetIntegerv(GL_VIEWPORT) 
    
    glSelectBuffer(512)
    glRenderMode(GL_SELECT) 
     
    glInitNames()
    glPushName(0)
    
    # prepare matrices
    glMatrixMode(GL_PROJECTION)
    glPushMatrix()
    glLoadIdentity()
    gluPickMatrix( x , height-y , 1, 1, viewport)
    gluPerspective(45, float(width)/float(height), 0.1, 100.0)
    
    glMatrixMode(GL_MODELVIEW) # Always load GL_MODELVIEW before drawing
    glPushMatrix()
    
    displayFunc(True)
    
    # restore matrices
    glMatrixMode(GL_PROJECTION)
    glPopMatrix()
    
    glMatrixMode(GL_MODELVIEW) # Always load GL_MODELVIEW before drawing
    glPopMatrix()
    
    # force completion
    glFlush()
    
    hits = glRenderMode(GL_RENDER)
    
    # hit[0] - min distance
    # hit[1] - max distance   
    # hit[2][0] - name 
    
    minDist = 1000
    id = -1    
    for hit in hits:
        if hit[0]< minDist:
            minDist = hit[0]
            id = hit[2][0] - 1 #names are id+1
        
    return id

def vectorMagnitude(v):
    mag = 0
    
    for i in v:
        mag += i*i
    
    mag = sqrt(mag)
    return mag

def normalizeVector(v):
    mag = vectorMagnitude(v)
    result = []
    
    for i in v:
        result.append( i/float(mag) )
        
    return result
    
    
def mouseFunc(button, state ,x ,y):
    global selectedPartId,mousePosition,model, xi, fi, vzd

    if button == GLUT_LEFT_BUTTON:
        if state == GLUT_DOWN:
            id = doPick(x, y)
            selectedPartId = id
            mousePosition = (x,y)
                
        elif state == GLUT_UP:
            if selectedPartId >-1:
                model.forceEndTime = time.time() + 5 # 5 sec force duration
                
                #calc force coordinates
                
                #mouse vector 
                v = ( x - mousePosition[0],  mousePosition[1]- y, 0)
                
                ang = fi -(pi/2)
                
                ang = - ang
                
                f = dot( array([[cos(ang),0,sin(ang)],[0,1,0],[-sin(ang),0,cos(ang)] ]) ,v )
                
                ang = - xi
                
                #f = normalizeVector(f)
                
                #print "force ", f
                
                model.applyForce( (f[0]/5.0, f[1]/5.0, f[2]/5.0),  selectedPartId )
            
    if button == GLUT_RIGHT_BUTTON:
        if state == GLUT_DOWN:
            pass
        elif state == GLUT_UP:
            pass
    
def keyboardFunc( key, x, y):
    global model
    global xi, fi, vzd
    
    if key == ' ':
        print "force!"
        model.applyForce( (0 ,-1.01,0), 0 )
    
    if key == 'q':
        vzd -= 0.5
    if key == 'e':
        vzd += 0.5
    if key == 'w':
        xi += 0.05
        if xi>1:
            xi = 1
        
    if key == 's':
        xi -= 0.05
        if xi<0.2:
            xi = 0.2
        
    if key == 'a':
        fi += 0.05
        if fi> 2*pi:
            fi = 0
        
    if key == 'd':
        fi -= 0.05
        if fi < 0:
            fi = 2*pi
        
    #print "xi ", xi, " fi ", fi, " vzd ", vzd    
        
    if key == 'r':
        model = None
        model = Model('../model.txt')
        
def main():
    global width, height
    
    glutInit()
    glutInitDisplayMode( GLUT_RGB | GLUT_DOUBLE)
    glutInitWindowSize(width, height)
    glutCreateWindow('rigid body dynamics')
    
    initGL(width, height)
    
    glutDisplayFunc( displayFunc )
    glutReshapeFunc( reSizeGLScene )
    glutIdleFunc( displayFunc )
    glutMouseFunc( mouseFunc )
    glutMotionFunc( mouseMotion )
    glutKeyboardFunc( keyboardFunc )
    
    glutMainLoop()

if __name__ == '__main__':
    model = Model('../model.txt')
    main()
